package com.pstreets.guice.demo;



import com.google.inject.Provides;
import com.google.inject.name.Names;
import com.google.inject.name.Named;
import com.mapdigit.drawing.geometry.Ellipse;
import com.mapdigit.drawing.geometry.IShape;
import com.mapdigit.drawing.geometry.Path;

import com.pstreets.guice.demo.provider.PathProvider;
import com.pstreets.guice.demo.shapes.MyRectangle;
import com.pstreets.guice.demo.shapes.MySquare;
import com.pstreets.guice.demo.annotation.Rectangle;
import com.pstreets.guice.demo.annotation.Square;
import com.pstreets.guice.demo.provider.PathProvider;

import roboguice.config.AbstractAndroidModule;

public class Graphics2DModule extends AbstractAndroidModule{

	@Override
	protected void configure() {
		
		//bind(IShape.class).to(MyRectangle.class);
		
		//bind(MyRectangle.class).to(MySquare.class);
		
		//bind(IShape.class)
		//.annotatedWith(Rectangle.class)
		//.to(MyRectangle.class);
		
		//bind(IShape.class)
		//.annotatedWith(Square.class)
		//.to(MySquare.class);
		
		bind(IShape.class)
		   .annotatedWith(Names.named("Rectangle"))
		   .to(MyRectangle.class);
		bind(IShape.class)
		   .annotatedWith(Names.named("Square"))
		   .to(MySquare.class);
		
		bind(Integer.class)
		   .annotatedWith(Names.named("width"))
		   .toInstance(100);
		bind(Integer.class)
		   .annotatedWith(Names.named("height"))
		   .toInstance(120);
		
		bind(Path.class).toProvider(PathProvider.class);

	}
	
	@Provides @Named("Circle1")
	IShape provideCircle1(){
		return new Ellipse(30,60,80,80);
	}
	
	@Provides @Named("Circle2")
	IShape provideCircle2(){
		return new Ellipse(60,30,80,80);
	}
	
	@Provides @Named("Circle3")
	IShape provideCircle3(){
		return new Ellipse(90,60,80,80);
	}
}
